]> git.street.me.uk Git - andy/dehydrated.git/blob - letsencrypt.sh
Add support for --keep-going in cron mode
[andy/dehydrated.git] / letsencrypt.sh
1 #!/usr/bin/env bash
2
3 # letsencrypt.sh by lukas2511
4 # Source: https://github.com/lukas2511/letsencrypt.sh
5 #
6 # This script is licensed under The MIT License (see LICENSE for more information).
7
8 set -e
9 set -u
10 set -o pipefail
11 [[ -n "${ZSH_VERSION:-}" ]] && set -o SH_WORD_SPLIT && set +o FUNCTION_ARGZERO
12 umask 077 # paranoid umask, we're creating private keys
13
14 # Find directory in which this script is stored by traversing all symbolic links
15 SOURCE="${0}"
16 while [ -h "$SOURCE" ]; do # resolve $SOURCE until the file is no longer a symlink
17   DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
18   SOURCE="$(readlink "$SOURCE")"
19   [[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE" # if $SOURCE was a relative symlink, we need to resolve it relative to the path where the symlink file was located
20 done
21 SCRIPTDIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
22
23 BASEDIR="${SCRIPTDIR}"
24
25 # Create (identifiable) temporary files
26 _mktemp() {
27   # shellcheck disable=SC2068
28   mktemp ${@:-} "${TMPDIR:-/tmp}/letsencrypt.sh-XXXXXX"
29 }
30
31 # Check for script dependencies
32 check_dependencies() {
33   # just execute some dummy and/or version commands to see if required tools exist and are actually usable
34   openssl version > /dev/null 2>&1 || _exiterr "This script requires an openssl binary."
35   _sed "" < /dev/null > /dev/null 2>&1 || _exiterr "This script requires sed with support for extended (modern) regular expressions."
36   command -v grep > /dev/null 2>&1 || _exiterr "This script requires grep."
37   _mktemp -u > /dev/null 2>&1 || _exiterr "This script requires mktemp."
38   diff -u /dev/null /dev/null || _exiterr "This script requires diff."
39
40   # curl returns with an error code in some ancient versions so we have to catch that
41   set +e
42   curl -V > /dev/null 2>&1
43   retcode="$?"
44   set -e
45   if [[ ! "${retcode}" = "0" ]] && [[ ! "${retcode}" = "2" ]]; then
46     _exiterr "This script requires curl."
47   fi
48 }
49
50 store_configvars() {
51   __KEY_ALGO="${KEY_ALGO}"
52   __OCSP_MUST_STAPLE="${OCSP_MUST_STAPLE}"
53   __PRIVATE_KEY_RENEW="${PRIVATE_KEY_RENEW}"
54   __KEYSIZE="${KEYSIZE}"
55   __CHALLENGETYPE="${CHALLENGETYPE}"
56   __HOOK="${HOOK}"
57   __WELLKNOWN="${WELLKNOWN}"
58   __HOOK_CHAIN="${HOOK_CHAIN}"
59   __OPENSSL_CNF="${OPENSSL_CNF}"
60   __RENEW_DAYS="${RENEW_DAYS}"
61   __IP_VERSION="${IP_VERSION}"
62 }
63
64 reset_configvars() {
65   KEY_ALGO="${__KEY_ALGO}"
66   OCSP_MUST_STAPLE="${__OCSP_MUST_STAPLE}"
67   PRIVATE_KEY_RENEW="${__PRIVATE_KEY_RENEW}"
68   KEYSIZE="${__KEYSIZE}"
69   CHALLENGETYPE="${__CHALLENGETYPE}"
70   HOOK="${__HOOK}"
71   WELLKNOWN="${__WELLKNOWN}"
72   HOOK_CHAIN="${__HOOK_CHAIN}"
73   OPENSSL_CNF="${__OPENSSL_CNF}"
74   RENEW_DAYS="${__RENEW_DAYS}"
75   IP_VERSION="${__IP_VERSION}"
76 }
77
78 # verify configuration values
79 verify_config() {
80   [[ "${CHALLENGETYPE}" =~ (http-01|dns-01) ]] || _exiterr "Unknown challenge type ${CHALLENGETYPE}... can not continue."
81   if [[ "${CHALLENGETYPE}" = "dns-01" ]] && [[ -z "${HOOK}" ]]; then
82     _exiterr "Challenge type dns-01 needs a hook script for deployment... can not continue."
83   fi
84   if [[ "${CHALLENGETYPE}" = "http-01" && ! -d "${WELLKNOWN}" ]]; then
85     _exiterr "WELLKNOWN directory doesn't exist, please create ${WELLKNOWN} and set appropriate permissions."
86   fi
87   [[ "${KEY_ALGO}" =~ ^(rsa|prime256v1|secp384r1)$ ]] || _exiterr "Unknown public key algorithm ${KEY_ALGO}... can not continue."
88   if [[ -n "${IP_VERSION}" ]]; then
89     [[ "${IP_VERSION}" = "4" || "${IP_VERSION}" = "6" ]] || _exiterr "Unknown IP version ${IP_VERSION}... can not continue."
90   fi
91 }
92
93 # Setup default config values, search for and load configuration files
94 load_config() {
95   # Check for config in various locations
96   if [[ -z "${CONFIG:-}" ]]; then
97     for check_config in "/etc/letsencrypt.sh" "/usr/local/etc/letsencrypt.sh" "${PWD}" "${SCRIPTDIR}"; do
98       if [[ -f "${check_config}/config" ]]; then
99         BASEDIR="${check_config}"
100         CONFIG="${check_config}/config"
101         break
102       fi
103     done
104   fi
105
106   # Default values
107   CA="https://acme-v01.api.letsencrypt.org/directory"
108   LICENSE="https://letsencrypt.org/documents/LE-SA-v1.1.1-August-1-2016.pdf"
109   CERTDIR=
110   ACCOUNTDIR=
111   CHALLENGETYPE="http-01"
112   CONFIG_D=
113   DOMAINS_D=
114   DOMAINS_TXT=
115   HOOK=
116   HOOK_CHAIN="no"
117   RENEW_DAYS="30"
118   KEYSIZE="4096"
119   WELLKNOWN=
120   PRIVATE_KEY_RENEW="yes"
121   KEY_ALGO=rsa
122   OPENSSL_CNF="$(openssl version -d | cut -d\" -f2)/openssl.cnf"
123   CONTACT_EMAIL=
124   LOCKFILE=
125   OCSP_MUST_STAPLE="no"
126   IP_VERSION=
127
128   if [[ -z "${CONFIG:-}" ]]; then
129     echo "#" >&2
130     echo "# !! WARNING !! No main config file found, using default config!" >&2
131     echo "#" >&2
132   elif [[ -f "${CONFIG}" ]]; then
133     echo "# INFO: Using main config file ${CONFIG}"
134     BASEDIR="$(dirname "${CONFIG}")"
135     # shellcheck disable=SC1090
136     . "${CONFIG}"
137   else
138     _exiterr "Specified config file doesn't exist."
139   fi
140
141   if [[ -n "${CONFIG_D}" ]]; then
142     if [[ ! -d "${CONFIG_D}" ]]; then
143       _exiterr "The path ${CONFIG_D} specified for CONFIG_D does not point to a directory." >&2
144     fi
145
146     for check_config_d in "${CONFIG_D}"/*.sh; do
147       if [[ ! -e "${check_config_d}" ]]; then
148         echo "# !! WARNING !! Extra configuration directory ${CONFIG_D} exists, but no configuration found in it." >&2
149         break
150       elif [[ -f "${check_config_d}" ]] && [[ -r "${check_config_d}" ]]; then
151         echo "# INFO: Using additional config file ${check_config_d}"
152         # shellcheck disable=SC1090
153         . "${check_config_d}"
154       else
155         _exiterr "Specified additional config ${check_config_d} is not readable or not a file at all." >&2
156       fi
157    done
158   fi
159
160   # Remove slash from end of BASEDIR. Mostly for cleaner outputs, doesn't change functionality.
161   BASEDIR="${BASEDIR%%/}"
162
163   # Check BASEDIR and set default variables
164   [[ -d "${BASEDIR}" ]] || _exiterr "BASEDIR does not exist: ${BASEDIR}"
165
166   CAHASH="$(echo "${CA}" | urlbase64)"
167   [[ -z "${ACCOUNTDIR}" ]] && ACCOUNTDIR="${BASEDIR}/accounts"
168   mkdir -p "${ACCOUNTDIR}/${CAHASH}"
169   [[ -f "${ACCOUNTDIR}/${CAHASH}/config" ]] && . "${ACCOUNTDIR}/${CAHASH}/config"
170   ACCOUNT_KEY="${ACCOUNTDIR}/${CAHASH}/account_key.pem"
171   ACCOUNT_KEY_JSON="${ACCOUNTDIR}/${CAHASH}/registration_info.json"
172
173   if [[ -f "${BASEDIR}/private_key.pem" ]] && [[ ! -f "${ACCOUNT_KEY}" ]]; then
174     echo "! Moving private_key.pem to ${ACCOUNT_KEY}"
175     mv "${BASEDIR}/private_key.pem" "${ACCOUNT_KEY}"
176   fi
177   if [[ -f "${BASEDIR}/private_key.json" ]] && [[ ! -f "${ACCOUNT_KEY_JSON}" ]]; then
178     echo "! Moving private_key.json to ${ACCOUNT_KEY_JSON}"
179     mv "${BASEDIR}/private_key.json" "${ACCOUNT_KEY_JSON}"
180   fi
181
182   [[ -z "${CERTDIR}" ]] && CERTDIR="${BASEDIR}/certs"
183   [[ -z "${DOMAINS_TXT}" ]] && DOMAINS_TXT="${BASEDIR}/domains.txt"
184   [[ -z "${WELLKNOWN}" ]] && WELLKNOWN="/var/www/letsencrypt"
185   [[ -z "${LOCKFILE}" ]] && LOCKFILE="${BASEDIR}/lock"
186   [[ -n "${PARAM_NO_LOCK:-}" ]] && LOCKFILE=""
187
188   [[ -n "${PARAM_HOOK:-}" ]] && HOOK="${PARAM_HOOK}"
189   [[ -n "${PARAM_CERTDIR:-}" ]] && CERTDIR="${PARAM_CERTDIR}"
190   [[ -n "${PARAM_CHALLENGETYPE:-}" ]] && CHALLENGETYPE="${PARAM_CHALLENGETYPE}"
191   [[ -n "${PARAM_KEY_ALGO:-}" ]] && KEY_ALGO="${PARAM_KEY_ALGO}"
192   [[ -n "${PARAM_OCSP_MUST_STAPLE:-}" ]] && OCSP_MUST_STAPLE="${PARAM_OCSP_MUST_STAPLE}"
193   [[ -n "${PARAM_IP_VERSION:-}" ]] && IP_VERSION="${PARAM_IP_VERSION}"
194
195   verify_config
196   store_configvars
197 }
198
199 # Initialize system
200 init_system() {
201   load_config
202
203   # Lockfile handling (prevents concurrent access)
204   if [[ -n "${LOCKFILE}" ]]; then
205     LOCKDIR="$(dirname "${LOCKFILE}")"
206     [[ -w "${LOCKDIR}" ]] || _exiterr "Directory ${LOCKDIR} for LOCKFILE ${LOCKFILE} is not writable, aborting."
207     ( set -C; date > "${LOCKFILE}" ) 2>/dev/null || _exiterr "Lock file '${LOCKFILE}' present, aborting."
208     remove_lock() { rm -f "${LOCKFILE}"; }
209     trap 'remove_lock' EXIT
210   fi
211
212   # Get CA URLs
213   CA_DIRECTORY="$(http_request get "${CA}")"
214   CA_NEW_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-cert)" &&
215   CA_NEW_AUTHZ="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-authz)" &&
216   CA_NEW_REG="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value new-reg)" &&
217   # shellcheck disable=SC2015
218   CA_REVOKE_CERT="$(printf "%s" "${CA_DIRECTORY}" | get_json_string_value revoke-cert)" ||
219   _exiterr "Problem retrieving ACME/CA-URLs, check if your configured CA points to the directory entrypoint."
220
221   # Export some environment variables to be used in hook script
222   export WELLKNOWN BASEDIR CERTDIR CONFIG
223
224   # Checking for private key ...
225   register_new_key="no"
226   if [[ -n "${PARAM_ACCOUNT_KEY:-}" ]]; then
227     # a private key was specified from the command line so use it for this run
228     echo "Using private key ${PARAM_ACCOUNT_KEY} instead of account key"
229     ACCOUNT_KEY="${PARAM_ACCOUNT_KEY}"
230     ACCOUNT_KEY_JSON="${PARAM_ACCOUNT_KEY}.json"
231   else
232     # Check if private account key exists, if it doesn't exist yet generate a new one (rsa key)
233     if [[ ! -e "${ACCOUNT_KEY}" ]]; then
234       echo "+ Generating account key..."
235       _openssl genrsa -out "${ACCOUNT_KEY}" "${KEYSIZE}"
236       register_new_key="yes"
237     fi
238   fi
239   openssl rsa -in "${ACCOUNT_KEY}" -check 2>/dev/null > /dev/null || _exiterr "Account key is not valid, can not continue."
240
241   # Get public components from private key and calculate thumbprint
242   pubExponent64="$(printf '%x' "$(openssl rsa -in "${ACCOUNT_KEY}" -noout -text | awk '/publicExponent/ {print $2}')" | hex2bin | urlbase64)"
243   pubMod64="$(openssl rsa -in "${ACCOUNT_KEY}" -noout -modulus | cut -d'=' -f2 | hex2bin | urlbase64)"
244
245   thumbprint="$(printf '{"e":"%s","kty":"RSA","n":"%s"}' "${pubExponent64}" "${pubMod64}" | openssl dgst -sha256 -binary | urlbase64)"
246
247   # If we generated a new private key in the step above we have to register it with the acme-server
248   if [[ "${register_new_key}" = "yes" ]]; then
249     echo "+ Registering account key with letsencrypt..."
250     [[ ! -z "${CA_NEW_REG}" ]] || _exiterr "Certificate authority doesn't allow registrations."
251     # If an email for the contact has been provided then adding it to the registration request
252     FAILED=false
253     if [[ -n "${CONTACT_EMAIL}" ]]; then
254       (signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "contact":["mailto:'"${CONTACT_EMAIL}"'"], "agreement": "'"$LICENSE"'"}' > "${ACCOUNT_KEY_JSON}") || FAILED=true
255     else
256       (signed_request "${CA_NEW_REG}" '{"resource": "new-reg", "agreement": "'"$LICENSE"'"}' > "${ACCOUNT_KEY_JSON}") || FAILED=true
257     fi
258     if [[ "${FAILED}" = "true" ]]; then
259       echo
260       echo
261       echo "Error registering account key. See message above for more information."
262       rm "${ACCOUNT_KEY}" "${ACCOUNT_KEY_JSON}"
263       exit 1
264     fi
265   fi
266
267 }
268
269 # Different sed version for different os types...
270 _sed() {
271   if [[ "${OSTYPE}" = "Linux" ]]; then
272     sed -r "${@}"
273   else
274     sed -E "${@}"
275   fi
276 }
277
278 # Print error message and exit with error
279 _exiterr() {
280   echo "ERROR: ${1}" >&2
281   exit 1
282 }
283
284 # Remove newlines and whitespace from json
285 clean_json() {
286   tr -d '\r\n' | _sed -e 's/ +/ /g' -e 's/\{ /{/g' -e 's/ \}/}/g' -e 's/\[ /[/g' -e 's/ \]/]/g'
287 }
288
289 # Encode data as url-safe formatted base64
290 urlbase64() {
291   # urlbase64: base64 encoded string with '+' replaced with '-' and '/' replaced with '_'
292   openssl base64 -e | tr -d '\n\r' | _sed -e 's:=*$::g' -e 'y:+/:-_:'
293 }
294
295 # Convert hex string to binary data
296 hex2bin() {
297   # Remove spaces, add leading zero, escape as hex string and parse with printf
298   printf -- "$(cat | _sed -e 's/[[:space:]]//g' -e 's/^(.(.{2})*)$/0\1/' -e 's/(.{2})/\\x\1/g')"
299 }
300
301 # Get string value from json dictionary
302 get_json_string_value() {
303   local filter
304   filter=$(printf 's/.*"%s": *"\([^"]*\)".*/\\1/p' "$1")
305   sed -n "${filter}"
306 }
307
308 # OpenSSL writes to stderr/stdout even when there are no errors. So just
309 # display the output if the exit code was != 0 to simplify debugging.
310 _openssl() {
311   set +e
312   out="$(openssl "${@}" 2>&1)"
313   res=$?
314   set -e
315   if [[ ${res} -ne 0 ]]; then
316     echo "  + ERROR: failed to run $* (Exitcode: ${res})" >&2
317     echo >&2
318     echo "Details:" >&2
319     echo "${out}" >&2
320     echo >&2
321     exit ${res}
322   fi
323 }
324
325 # Send http(s) request with specified method
326 http_request() {
327   tempcont="$(_mktemp)"
328
329   if [[ -n "${IP_VERSION:-}" ]]; then
330       ip_version="-${IP_VERSION}"
331   fi
332
333   set +e
334   if [[ "${1}" = "head" ]]; then
335     statuscode="$(curl ${ip_version:-} -s -w "%{http_code}" -o "${tempcont}" "${2}" -I)"
336     curlret="${?}"
337   elif [[ "${1}" = "get" ]]; then
338     statuscode="$(curl ${ip_version:-} -s -w "%{http_code}" -o "${tempcont}" "${2}")"
339     curlret="${?}"
340   elif [[ "${1}" = "post" ]]; then
341     statuscode="$(curl ${ip_version:-} -s -w "%{http_code}" -o "${tempcont}" "${2}" -d "${3}")"
342     curlret="${?}"
343   else
344     set -e
345     _exiterr "Unknown request method: ${1}"
346   fi
347   set -e
348
349   if [[ ! "${curlret}" = "0" ]]; then
350     _exiterr "Problem connecting to server (${1} for ${2}; curl returned with ${curlret})"
351   fi
352
353   if [[ ! "${statuscode:0:1}" = "2" ]]; then
354     echo "  + ERROR: An error occurred while sending ${1}-request to ${2} (Status ${statuscode})" >&2
355     echo >&2
356     echo "Details:" >&2
357     cat "${tempcont}" >&2
358     rm -f "${tempcont}"
359
360     # Wait for hook script to clean the challenge if used
361     if [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && [[ -n "${challenge_token:+set}" ]]; then
362       "${HOOK}" "clean_challenge" '' "${challenge_token}" "${keyauth}"
363     fi
364
365     # remove temporary domains.txt file if used
366     [[ -n "${PARAM_DOMAIN:-}" && -n "${DOMAINS_TXT:-}" ]] && rm "${DOMAINS_TXT}"
367     exit 1
368   fi
369
370   cat "${tempcont}"
371   rm -f "${tempcont}"
372 }
373
374 # Send signed request
375 signed_request() {
376   # Encode payload as urlbase64
377   payload64="$(printf '%s' "${2}" | urlbase64)"
378
379   # Retrieve nonce from acme-server
380   nonce="$(http_request head "${CA}" | grep Replay-Nonce: | awk -F ': ' '{print $2}' | tr -d '\n\r')"
381
382   # Build header with just our public key and algorithm information
383   header='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}}'
384
385   # Build another header which also contains the previously received nonce and encode it as urlbase64
386   protected='{"alg": "RS256", "jwk": {"e": "'"${pubExponent64}"'", "kty": "RSA", "n": "'"${pubMod64}"'"}, "nonce": "'"${nonce}"'"}'
387   protected64="$(printf '%s' "${protected}" | urlbase64)"
388
389   # Sign header with nonce and our payload with our private key and encode signature as urlbase64
390   signed64="$(printf '%s' "${protected64}.${payload64}" | openssl dgst -sha256 -sign "${ACCOUNT_KEY}" | urlbase64)"
391
392   # Send header + extended header + payload + signature to the acme-server
393   data='{"header": '"${header}"', "protected": "'"${protected64}"'", "payload": "'"${payload64}"'", "signature": "'"${signed64}"'"}'
394
395   http_request post "${1}" "${data}"
396 }
397
398 # Extracts all subject names from a CSR
399 # Outputs either the CN, or the SANs, one per line
400 extract_altnames() {
401   csr="${1}" # the CSR itself (not a file)
402
403   if ! <<<"${csr}" openssl req -verify -noout 2>/dev/null; then
404     _exiterr "Certificate signing request isn't valid"
405   fi
406
407   reqtext="$( <<<"${csr}" openssl req -noout -text )"
408   if <<<"${reqtext}" grep -q '^[[:space:]]*X509v3 Subject Alternative Name:[[:space:]]*$'; then
409     # SANs used, extract these
410     altnames="$( <<<"${reqtext}" grep -A1 '^[[:space:]]*X509v3 Subject Alternative Name:[[:space:]]*$' | tail -n1 )"
411     # split to one per line:
412     # shellcheck disable=SC1003
413     altnames="$( <<<"${altnames}" _sed -e 's/^[[:space:]]*//; s/, /\'$'\n''/g' )"
414     # we can only get DNS: ones signed
415     if grep -qv '^DNS:' <<<"${altnames}"; then
416       _exiterr "Certificate signing request contains non-DNS Subject Alternative Names"
417     fi
418     # strip away the DNS: prefix
419     altnames="$( <<<"${altnames}" _sed -e 's/^DNS://' )"
420     echo "${altnames}"
421
422   else
423     # No SANs, extract CN
424     altnames="$( <<<"${reqtext}" grep '^[[:space:]]*Subject:' | _sed -e 's/.* CN=([^ /,]*).*/\1/' )"
425     echo "${altnames}"
426   fi
427 }
428
429 # Create certificate for domain(s) and outputs it FD 3
430 sign_csr() {
431   csr="${1}" # the CSR itself (not a file)
432
433   if { true >&3; } 2>/dev/null; then
434     : # fd 3 looks OK
435   else
436     _exiterr "sign_csr: FD 3 not open"
437   fi
438
439   shift 1 || true
440   altnames="${*:-}"
441   if [ -z "${altnames}" ]; then
442     altnames="$( extract_altnames "${csr}" )"
443   fi
444
445   if [[ -z "${CA_NEW_AUTHZ}" ]] || [[ -z "${CA_NEW_CERT}" ]]; then
446     _exiterr "Certificate authority doesn't allow certificate signing"
447   fi
448
449   local idx=0
450   if [[ -n "${ZSH_VERSION:-}" ]]; then
451     local -A challenge_uris challenge_tokens keyauths deploy_args
452   else
453     local -a challenge_uris challenge_tokens keyauths deploy_args
454   fi
455
456   # Request challenges
457   for altname in ${altnames}; do
458     # Ask the acme-server for new challenge token and extract them from the resulting json block
459     echo " + Requesting challenge for ${altname}..."
460     response="$(signed_request "${CA_NEW_AUTHZ}" '{"resource": "new-authz", "identifier": {"type": "dns", "value": "'"${altname}"'"}}' | clean_json)"
461
462     challenges="$(printf '%s\n' "${response}" | sed -n 's/.*\("challenges":[^\[]*\[[^]]*]\).*/\1/p')"
463     repl=$'\n''{' # fix syntax highlighting in Vim
464     challenge="$(printf "%s" "${challenges//\{/${repl}}" | grep \""${CHALLENGETYPE}"\")"
465     challenge_token="$(printf '%s' "${challenge}" | get_json_string_value token | _sed 's/[^A-Za-z0-9_\-]/_/g')"
466     challenge_uri="$(printf '%s' "${challenge}" | get_json_string_value uri)"
467
468     if [[ -z "${challenge_token}" ]] || [[ -z "${challenge_uri}" ]]; then
469       _exiterr "Can't retrieve challenges (${response})"
470     fi
471
472     # Challenge response consists of the challenge token and the thumbprint of our public certificate
473     keyauth="${challenge_token}.${thumbprint}"
474
475     case "${CHALLENGETYPE}" in
476       "http-01")
477         # Store challenge response in well-known location and make world-readable (so that a webserver can access it)
478         printf '%s' "${keyauth}" > "${WELLKNOWN}/${challenge_token}"
479         chmod a+r "${WELLKNOWN}/${challenge_token}"
480         keyauth_hook="${keyauth}"
481         ;;
482       "dns-01")
483         # Generate DNS entry content for dns-01 validation
484         keyauth_hook="$(printf '%s' "${keyauth}" | openssl dgst -sha256 -binary | urlbase64)"
485         ;;
486     esac
487
488     challenge_uris[${idx}]="${challenge_uri}"
489     keyauths[${idx}]="${keyauth}"
490     challenge_tokens[${idx}]="${challenge_token}"
491     # Note: assumes args will never have spaces!
492     deploy_args[${idx}]="${altname} ${challenge_token} ${keyauth_hook}"
493     idx=$((idx+1))
494   done
495
496   # Wait for hook script to deploy the challenges if used
497   # shellcheck disable=SC2068
498   [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" = "yes" ]] && "${HOOK}" "deploy_challenge" ${deploy_args[@]}
499
500   # Respond to challenges
501   idx=0
502   for altname in ${altnames}; do
503     challenge_token="${challenge_tokens[${idx}]}"
504     keyauth="${keyauths[${idx}]}"
505
506     # Wait for hook script to deploy the challenge if used
507     # shellcheck disable=SC2086
508     [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && "${HOOK}" "deploy_challenge" ${deploy_args[${idx}]}
509
510     # Ask the acme-server to verify our challenge and wait until it is no longer pending
511     echo " + Responding to challenge for ${altname}..."
512     result="$(signed_request "${challenge_uris[${idx}]}" '{"resource": "challenge", "keyAuthorization": "'"${keyauth}"'"}' | clean_json)"
513
514     reqstatus="$(printf '%s\n' "${result}" | get_json_string_value status)"
515
516     while [[ "${reqstatus}" = "pending" ]]; do
517       sleep 1
518       result="$(http_request get "${challenge_uris[${idx}]}")"
519       reqstatus="$(printf '%s\n' "${result}" | get_json_string_value status)"
520     done
521
522     [[ "${CHALLENGETYPE}" = "http-01" ]] && rm -f "${WELLKNOWN}/${challenge_token}"
523
524     # Wait for hook script to clean the challenge if used
525     if [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" != "yes" ]] && [[ -n "${challenge_token}" ]]; then
526       # shellcheck disable=SC2086
527       "${HOOK}" "clean_challenge" ${deploy_args[${idx}]}
528     fi
529     idx=$((idx+1))
530
531     if [[ "${reqstatus}" = "valid" ]]; then
532       echo " + Challenge is valid!"
533     else
534       break
535     fi
536   done
537
538   # Wait for hook script to clean the challenges if used
539   # shellcheck disable=SC2068
540   [[ -n "${HOOK}" ]] && [[ "${HOOK_CHAIN}" = "yes" ]] && "${HOOK}" "clean_challenge" ${deploy_args[@]}
541
542   if [[ "${reqstatus}" != "valid" ]]; then
543     # Clean up any remaining challenge_tokens if we stopped early
544     if [[ "${CHALLENGETYPE}" = "http-01" ]]; then
545       while [ ${idx} -lt ${#challenge_tokens[@]} ]; do
546         rm -f "${WELLKNOWN}/${challenge_tokens[${idx}]}"
547         idx=$((idx+1))
548       done
549     fi
550
551     _exiterr "Challenge is invalid! (returned: ${reqstatus}) (result: ${result})"
552   fi
553
554   # Finally request certificate from the acme-server and store it in cert-${timestamp}.pem and link from cert.pem
555   echo " + Requesting certificate..."
556   csr64="$( <<<"${csr}" openssl req -outform DER | urlbase64)"
557   crt64="$(signed_request "${CA_NEW_CERT}" '{"resource": "new-cert", "csr": "'"${csr64}"'"}' | openssl base64 -e)"
558   crt="$( printf -- '-----BEGIN CERTIFICATE-----\n%s\n-----END CERTIFICATE-----\n' "${crt64}" )"
559
560   # Try to load the certificate to detect corruption
561   echo " + Checking certificate..."
562   _openssl x509 -text <<<"${crt}"
563
564   echo "${crt}" >&3
565
566   unset challenge_token
567   echo " + Done!"
568 }
569
570 # Create certificate for domain(s)
571 sign_domain() {
572   domain="${1}"
573   altnames="${*}"
574   timestamp="$(date +%s)"
575
576   echo " + Signing domains..."
577   if [[ -z "${CA_NEW_AUTHZ}" ]] || [[ -z "${CA_NEW_CERT}" ]]; then
578     _exiterr "Certificate authority doesn't allow certificate signing"
579   fi
580
581   # If there is no existing certificate directory => make it
582   if [[ ! -e "${CERTDIR}/${domain}" ]]; then
583     echo " + Creating new directory ${CERTDIR}/${domain} ..."
584     mkdir -p "${CERTDIR}/${domain}" || _exiterr "Unable to create directory ${CERTDIR}/${domain}"
585   fi
586
587   privkey="privkey.pem"
588   # generate a new private key if we need or want one
589   if [[ ! -r "${CERTDIR}/${domain}/privkey.pem" ]] || [[ "${PRIVATE_KEY_RENEW}" = "yes" ]]; then
590     echo " + Generating private key..."
591     privkey="privkey-${timestamp}.pem"
592     case "${KEY_ALGO}" in
593       rsa) _openssl genrsa -out "${CERTDIR}/${domain}/privkey-${timestamp}.pem" "${KEYSIZE}";;
594       prime256v1|secp384r1) _openssl ecparam -genkey -name "${KEY_ALGO}" -out "${CERTDIR}/${domain}/privkey-${timestamp}.pem";;
595     esac
596   fi
597
598   # Generate signing request config and the actual signing request
599   echo " + Generating signing request..."
600   SAN=""
601   for altname in ${altnames}; do
602     SAN+="DNS:${altname}, "
603   done
604   SAN="${SAN%%, }"
605   local tmp_openssl_cnf
606   tmp_openssl_cnf="$(_mktemp)"
607   cat "${OPENSSL_CNF}" > "${tmp_openssl_cnf}"
608   printf "[SAN]\nsubjectAltName=%s" "${SAN}" >> "${tmp_openssl_cnf}"
609   if [ "${OCSP_MUST_STAPLE}" = "yes" ]; then
610     printf "\n1.3.6.1.5.5.7.1.24=DER:30:03:02:01:05" >> "${tmp_openssl_cnf}"
611   fi
612   openssl req -new -sha256 -key "${CERTDIR}/${domain}/${privkey}" -out "${CERTDIR}/${domain}/cert-${timestamp}.csr" -subj "/CN=${domain}/" -reqexts SAN -config "${tmp_openssl_cnf}"
613   rm -f "${tmp_openssl_cnf}"
614
615   crt_path="${CERTDIR}/${domain}/cert-${timestamp}.pem"
616   # shellcheck disable=SC2086
617   sign_csr "$(< "${CERTDIR}/${domain}/cert-${timestamp}.csr" )" ${altnames} 3>"${crt_path}"
618
619   # Create fullchain.pem
620   echo " + Creating fullchain.pem..."
621   cat "${crt_path}" > "${CERTDIR}/${domain}/fullchain-${timestamp}.pem"
622   http_request get "$(openssl x509 -in "${CERTDIR}/${domain}/cert-${timestamp}.pem" -noout -text | grep 'CA Issuers - URI:' | cut -d':' -f2-)" > "${CERTDIR}/${domain}/chain-${timestamp}.pem"
623   if ! grep -q "BEGIN CERTIFICATE" "${CERTDIR}/${domain}/chain-${timestamp}.pem"; then
624     openssl x509 -in "${CERTDIR}/${domain}/chain-${timestamp}.pem" -inform DER -out "${CERTDIR}/${domain}/chain-${timestamp}.pem" -outform PEM
625   fi
626   cat "${CERTDIR}/${domain}/chain-${timestamp}.pem" >> "${CERTDIR}/${domain}/fullchain-${timestamp}.pem"
627
628   # Update symlinks
629   [[ "${privkey}" = "privkey.pem" ]] || ln -sf "privkey-${timestamp}.pem" "${CERTDIR}/${domain}/privkey.pem"
630
631   ln -sf "chain-${timestamp}.pem" "${CERTDIR}/${domain}/chain.pem"
632   ln -sf "fullchain-${timestamp}.pem" "${CERTDIR}/${domain}/fullchain.pem"
633   ln -sf "cert-${timestamp}.csr" "${CERTDIR}/${domain}/cert.csr"
634   ln -sf "cert-${timestamp}.pem" "${CERTDIR}/${domain}/cert.pem"
635
636   # Wait for hook script to clean the challenge and to deploy cert if used
637   export KEY_ALGO
638   [[ -n "${HOOK}" ]] && "${HOOK}" "deploy_cert" "${domain}" "${CERTDIR}/${domain}/privkey.pem" "${CERTDIR}/${domain}/cert.pem" "${CERTDIR}/${domain}/fullchain.pem" "${CERTDIR}/${domain}/chain.pem" "${timestamp}"
639
640   unset challenge_token
641   echo " + Done!"
642 }
643
644 # Usage: --cron (-c)
645 # Description: Sign/renew non-existant/changed/expiring certificates.
646 command_sign_domains() {
647   init_system
648
649   if [[ -n "${PARAM_DOMAIN:-}" ]]; then
650     DOMAINS_TXT="$(_mktemp)"
651     printf -- "${PARAM_DOMAIN}" > "${DOMAINS_TXT}"
652   elif [[ -e "${DOMAINS_TXT}" ]]; then
653     if [[ ! -r "${DOMAINS_TXT}" ]]; then
654       _exiterr "domains.txt found but not readable"
655     fi
656   else
657     _exiterr "domains.txt not found and --domain not given"
658   fi
659
660   # Generate certificates for all domains found in domains.txt. Check if existing certificate are about to expire
661   ORIGIFS="${IFS}"
662   IFS=$'\n'
663   for line in $(<"${DOMAINS_TXT}" tr -d '\r' | tr '[:upper:]' '[:lower:]' | _sed -e 's/^[[:space:]]*//g' -e 's/[[:space:]]*$//g' -e 's/[[:space:]]+/ /g' | (grep -vE '^(#|$)' || true)); do
664     reset_configvars
665     IFS="${ORIGIFS}"
666     domain="$(printf '%s\n' "${line}" | cut -d' ' -f1)"
667     morenames="$(printf '%s\n' "${line}" | cut -s -d' ' -f2-)"
668     cert="${CERTDIR}/${domain}/cert.pem"
669
670     force_renew="${PARAM_FORCE:-no}"
671
672     if [[ -z "${morenames}" ]];then
673       echo "Processing ${domain}"
674     else
675       echo "Processing ${domain} with alternative names: ${morenames}"
676     fi
677
678     # read cert config
679     # for now this loads the certificate specific config in a subshell and parses a diff of set variables.
680     # we could just source the config file but i decided to go this way to protect people from accidentally overriding
681     # variables used internally by this script itself.
682     if [[ -n "${DOMAINS_D}" ]]; then
683       certconfig="${DOMAINS_D}/${domain}"
684     else
685       certconfig="${CERTDIR}/${domain}/config"
686     fi
687
688     if [ -f "${certconfig}" ]; then
689       echo " + Using certificate specific config file!"
690       ORIGIFS="${IFS}"
691       IFS=$'\n'
692       for cfgline in $(
693         beforevars="$(_mktemp)"
694         aftervars="$(_mktemp)"
695         set > "${beforevars}"
696         # shellcheck disable=SC1090
697         . "${certconfig}"
698         set > "${aftervars}"
699         diff -u "${beforevars}" "${aftervars}" | grep -E '^\+[^+]'
700         rm "${beforevars}"
701         rm "${aftervars}"
702       ); do
703         config_var="$(echo "${cfgline:1}" | cut -d'=' -f1)"
704         config_value="$(echo "${cfgline:1}" | cut -d'=' -f2-)"
705         case "${config_var}" in
706           KEY_ALGO|OCSP_MUST_STAPLE|PRIVATE_KEY_RENEW|KEYSIZE|CHALLENGETYPE|HOOK|WELLKNOWN|HOOK_CHAIN|OPENSSL_CNF|RENEW_DAYS)
707             echo "   + ${config_var} = ${config_value}"
708             declare -- "${config_var}=${config_value}"
709             ;;
710           _) ;;
711           *) echo "   ! Setting ${config_var} on a per-certificate base is not (yet) supported"
712         esac
713       done
714       IFS="${ORIGIFS}"
715     fi
716     verify_config
717
718     if [[ -e "${cert}" ]]; then
719       printf " + Checking domain name(s) of existing cert..."
720
721       certnames="$(openssl x509 -in "${cert}" -text -noout | grep DNS: | _sed 's/DNS://g' | tr -d ' ' | tr ',' '\n' | sort -u | tr '\n' ' ' | _sed 's/ $//')"
722       givennames="$(echo "${domain}" "${morenames}"| tr ' ' '\n' | sort -u | tr '\n' ' ' | _sed 's/ $//' | _sed 's/^ //')"
723
724       if [[ "${certnames}" = "${givennames}" ]]; then
725         echo " unchanged."
726       else
727         echo " changed!"
728         echo " + Domain name(s) are not matching!"
729         echo " + Names in old certificate: ${certnames}"
730         echo " + Configured names: ${givennames}"
731         echo " + Forcing renew."
732         force_renew="yes"
733       fi
734     fi
735
736     if [[ -e "${cert}" ]]; then
737       echo " + Checking expire date of existing cert..."
738       valid="$(openssl x509 -enddate -noout -in "${cert}" | cut -d= -f2- )"
739
740       printf " + Valid till %s " "${valid}"
741       if openssl x509 -checkend $((RENEW_DAYS * 86400)) -noout -in "${cert}"; then
742         printf "(Longer than %d days). " "${RENEW_DAYS}"
743         if [[ "${force_renew}" = "yes" ]]; then
744           echo "Ignoring because renew was forced!"
745         else
746           # Certificate-Names unchanged and cert is still valid
747           echo "Skipping renew!"
748           [[ -n "${HOOK}" ]] && "${HOOK}" "unchanged_cert" "${domain}" "${CERTDIR}/${domain}/privkey.pem" "${CERTDIR}/${domain}/cert.pem" "${CERTDIR}/${domain}/fullchain.pem" "${CERTDIR}/${domain}/chain.pem"
749           continue
750         fi
751       else
752         echo "(Less than ${RENEW_DAYS} days). Renewing!"
753       fi
754     fi
755
756     # shellcheck disable=SC2086
757     if [[ "${PARAM_KEEP_GOING:-}" = "yes" ]]; then
758       sign_domain ${line} &
759       wait $! || true
760     else
761       sign_domain ${line}
762     fi
763   done
764
765   # remove temporary domains.txt file if used
766   [[ -n "${PARAM_DOMAIN:-}" ]] && rm -f "${DOMAINS_TXT}"
767
768   exit 0
769 }
770
771 # Usage: --signcsr (-s) path/to/csr.pem
772 # Description: Sign a given CSR, output CRT on stdout (advanced usage)
773 command_sign_csr() {
774   # redirect stdout to stderr
775   # leave stdout over at fd 3 to output the cert
776   exec 3>&1 1>&2
777
778   init_system
779
780   csrfile="${1}"
781   if [ ! -r "${csrfile}" ]; then
782     _exiterr "Could not read certificate signing request ${csrfile}"
783   fi
784
785   # gen cert
786   certfile="$(_mktemp)"
787   sign_csr "$(< "${csrfile}" )" 3> "${certfile}"
788
789   # get and convert ca cert
790   chainfile="$(_mktemp)"
791   http_request get "$(openssl x509 -in "${certfile}" -noout -text | grep 'CA Issuers - URI:' | cut -d':' -f2-)" > "${chainfile}"
792
793   if ! grep -q "BEGIN CERTIFICATE" "${chainfile}"; then
794     openssl x509 -inform DER -in "${chainfile}" -outform PEM -out "${chainfile}"
795   fi
796
797   # output full chain
798   echo "# CERT #" >&3
799   cat "${certfile}" >&3
800   echo >&3
801   echo "# CHAIN #" >&3
802   cat "${chainfile}" >&3
803
804   # cleanup
805   rm "${certfile}"
806   rm "${chainfile}"
807
808   exit 0
809 }
810
811 # Usage: --revoke (-r) path/to/cert.pem
812 # Description: Revoke specified certificate
813 command_revoke() {
814   init_system
815
816   [[ -n "${CA_REVOKE_CERT}" ]] || _exiterr "Certificate authority doesn't allow certificate revocation."
817
818   cert="${1}"
819   if [[ -L "${cert}" ]]; then
820     # follow symlink and use real certificate name (so we move the real file and not the symlink at the end)
821     local link_target
822     link_target="$(readlink -n "${cert}")"
823     if [[ "${link_target}" =~ ^/ ]]; then
824       cert="${link_target}"
825     else
826       cert="$(dirname "${cert}")/${link_target}"
827     fi
828   fi
829   [[ -f "${cert}" ]] || _exiterr "Could not find certificate ${cert}"
830
831   echo "Revoking ${cert}"
832
833   cert64="$(openssl x509 -in "${cert}" -inform PEM -outform DER | urlbase64)"
834   response="$(signed_request "${CA_REVOKE_CERT}" '{"resource": "revoke-cert", "certificate": "'"${cert64}"'"}' | clean_json)"
835   # if there is a problem with our revoke request _request (via signed_request) will report this and "exit 1" out
836   # so if we are here, it is safe to assume the request was successful
837   echo " + Done."
838   echo " + Renaming certificate to ${cert}-revoked"
839   mv -f "${cert}" "${cert}-revoked"
840 }
841
842 # Usage: --cleanup (-gc)
843 # Description: Move unused certificate files to archive directory
844 command_cleanup() {
845   load_config
846
847   # Create global archive directory if not existant
848   if [[ ! -e "${BASEDIR}/archive" ]]; then
849     mkdir "${BASEDIR}/archive"
850   fi
851
852   # Loop over all certificate directories
853   for certdir in "${CERTDIR}/"*; do
854     # Skip if entry is not a folder
855     [[ -d "${certdir}" ]] || continue
856
857     # Get certificate name
858     certname="$(basename "${certdir}")"
859
860     # Create certitifaces archive directory if not existant
861     archivedir="${BASEDIR}/archive/${certname}"
862     if [[ ! -e "${archivedir}" ]]; then
863       mkdir "${archivedir}"
864     fi
865
866     # Loop over file-types (certificates, keys, signing-requests, ...)
867     for filetype in cert.csr cert.pem chain.pem fullchain.pem privkey.pem; do
868       # Skip if symlink is broken
869       [[ -r "${certdir}/${filetype}" ]] || continue
870
871       # Look up current file in use
872       current="$(basename "$(readlink "${certdir}/${filetype}")")"
873
874       # Split filetype into name and extension
875       filebase="$(echo "${filetype}" | cut -d. -f1)"
876       fileext="$(echo "${filetype}" | cut -d. -f2)"
877
878       # Loop over all files of this type
879       for file in "${certdir}/${filebase}-"*".${fileext}"; do
880         # Handle case where no files match the wildcard
881         [[ -f "${file}" ]] || break
882
883         # Check if current file is in use, if unused move to archive directory
884         filename="$(basename "${file}")"
885         if [[ ! "${filename}" = "${current}" ]]; then
886           echo "Moving unused file to archive directory: ${certname}/${filename}"
887           mv "${certdir}/${filename}" "${archivedir}/${filename}"
888         fi
889       done
890     done
891   done
892
893   exit 0
894 }
895
896 # Usage: --help (-h)
897 # Description: Show help text
898 command_help() {
899   printf "Usage: %s [-h] [command [argument]] [parameter [argument]] [parameter [argument]] ...\n\n" "${0}"
900   printf "Default command: help\n\n"
901   echo "Commands:"
902   grep -e '^[[:space:]]*# Usage:' -e '^[[:space:]]*# Description:' -e '^command_.*()[[:space:]]*{' "${0}" | while read -r usage; read -r description; read -r command; do
903     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]] || [[ ! "${command}" =~ ^command_ ]]; then
904       _exiterr "Error generating help text."
905     fi
906     printf " %-32s %s\n" "${usage##"# Usage: "}" "${description##"# Description: "}"
907   done
908   printf -- "\nParameters:\n"
909   grep -E -e '^[[:space:]]*# PARAM_Usage:' -e '^[[:space:]]*# PARAM_Description:' "${0}" | while read -r usage; read -r description; do
910     if [[ ! "${usage}" =~ Usage ]] || [[ ! "${description}" =~ Description ]]; then
911       _exiterr "Error generating help text."
912     fi
913     printf " %-32s %s\n" "${usage##"# PARAM_Usage: "}" "${description##"# PARAM_Description: "}"
914   done
915 }
916
917 # Usage: --env (-e)
918 # Description: Output configuration variables for use in other scripts
919 command_env() {
920   echo "# letsencrypt.sh configuration"
921   load_config
922   typeset -p CA LICENSE CERTDIR CHALLENGETYPE DOMAINS_D DOMAINS_TXT HOOK HOOK_CHAIN RENEW_DAYS ACCOUNT_KEY ACCOUNT_KEY_JSON KEYSIZE WELLKNOWN PRIVATE_KEY_RENEW OPENSSL_CNF CONTACT_EMAIL LOCKFILE
923 }
924
925 # Main method (parses script arguments and calls command_* methods)
926 main() {
927   COMMAND=""
928   set_command() {
929     [[ -z "${COMMAND}" ]] || _exiterr "Only one command can be executed at a time. See help (-h) for more information."
930     COMMAND="${1}"
931   }
932
933   check_parameters() {
934     if [[ -z "${1:-}" ]]; then
935       echo "The specified command requires additional parameters. See help:" >&2
936       echo >&2
937       command_help >&2
938       exit 1
939     elif [[ "${1:0:1}" = "-" ]]; then
940       _exiterr "Invalid argument: ${1}"
941     fi
942   }
943
944   [[ -z "${@}" ]] && eval set -- "--help"
945
946   while (( ${#} )); do
947     case "${1}" in
948       --help|-h)
949         command_help
950         exit 0
951         ;;
952
953       --env|-e)
954         set_command env
955         ;;
956
957       --cron|-c)
958         set_command sign_domains
959         ;;
960
961       --signcsr|-s)
962         shift 1
963         set_command sign_csr
964         check_parameters "${1:-}"
965         PARAM_CSR="${1}"
966         ;;
967
968       --revoke|-r)
969         shift 1
970         set_command revoke
971         check_parameters "${1:-}"
972         PARAM_REVOKECERT="${1}"
973         ;;
974
975       --cleanup|-gc)
976         set_command cleanup
977         ;;
978
979       # PARAM_Usage: --ipv4 (-4)
980       # PARAM_Description: Resolve names to IPv4 addresses only
981       --ipv4|-4)
982         PARAM_IP_VERSION="4"
983         ;;
984
985       # PARAM_Usage: --ipv6 (-6)
986       # PARAM_Description: Resolve names to IPv6 addresses only
987       --ipv6|-6)
988         PARAM_IP_VERSION="6"
989         ;;
990
991       # PARAM_Usage: --domain (-d) domain.tld
992       # PARAM_Description: Use specified domain name(s) instead of domains.txt entry (one certificate!)
993       --domain|-d)
994         shift 1
995         check_parameters "${1:-}"
996         if [[ -z "${PARAM_DOMAIN:-}" ]]; then
997           PARAM_DOMAIN="${1}"
998         else
999           PARAM_DOMAIN="${PARAM_DOMAIN} ${1}"
1000          fi
1001         ;;
1002
1003       # PARAM_Usage: --keep-going (-g)
1004       # PARAM_Description: Keep going after encountering an error while creating/renewing multiple certificates in cron mode
1005       --keep-going|-g)
1006         PARAM_KEEP_GOING="yes"
1007         ;;
1008
1009       # PARAM_Usage: --force (-x)
1010       # PARAM_Description: Force renew of certificate even if it is longer valid than value in RENEW_DAYS
1011       --force|-x)
1012         PARAM_FORCE="yes"
1013         ;;
1014
1015       # PARAM_Usage: --no-lock (-n)
1016       # PARAM_Description: Don't use lockfile (potentially dangerous!)
1017       --no-lock|-n)
1018         PARAM_NO_LOCK="yes"
1019         ;;
1020
1021       # PARAM_Usage: --ocsp
1022       # PARAM_Description: Sets option in CSR indicating OCSP stapling to be mandatory
1023       --ocsp)
1024         PARAM_OCSP_MUST_STAPLE="yes"
1025         ;;
1026
1027       # PARAM_Usage: --privkey (-p) path/to/key.pem
1028       # PARAM_Description: Use specified private key instead of account key (useful for revocation)
1029       --privkey|-p)
1030         shift 1
1031         check_parameters "${1:-}"
1032         PARAM_ACCOUNT_KEY="${1}"
1033         ;;
1034
1035       # PARAM_Usage: --config (-f) path/to/config
1036       # PARAM_Description: Use specified config file
1037       --config|-f)
1038         shift 1
1039         check_parameters "${1:-}"
1040         CONFIG="${1}"
1041         ;;
1042
1043       # PARAM_Usage: --hook (-k) path/to/hook.sh
1044       # PARAM_Description: Use specified script for hooks
1045       --hook|-k)
1046         shift 1
1047         check_parameters "${1:-}"
1048         PARAM_HOOK="${1}"
1049         ;;
1050
1051       # PARAM_Usage: --out (-o) certs/directory
1052       # PARAM_Description: Output certificates into the specified directory
1053       --out|-o)
1054         shift 1
1055         check_parameters "${1:-}"
1056         PARAM_CERTDIR="${1}"
1057         ;;
1058
1059       # PARAM_Usage: --challenge (-t) http-01|dns-01
1060       # PARAM_Description: Which challenge should be used? Currently http-01 and dns-01 are supported
1061       --challenge|-t)
1062         shift 1
1063         check_parameters "${1:-}"
1064         PARAM_CHALLENGETYPE="${1}"
1065         ;;
1066
1067       # PARAM_Usage: --algo (-a) rsa|prime256v1|secp384r1
1068       # PARAM_Description: Which public key algorithm should be used? Supported: rsa, prime256v1 and secp384r1
1069       --algo|-a)
1070         shift 1
1071         check_parameters "${1:-}"
1072         PARAM_KEY_ALGO="${1}"
1073         ;;
1074
1075       *)
1076         echo "Unknown parameter detected: ${1}" >&2
1077         echo >&2
1078         command_help >&2
1079         exit 1
1080         ;;
1081     esac
1082
1083     shift 1
1084   done
1085
1086   case "${COMMAND}" in
1087     env) command_env;;
1088     sign_domains) command_sign_domains;;
1089     sign_csr) command_sign_csr "${PARAM_CSR}";;
1090     revoke) command_revoke "${PARAM_REVOKECERT}";;
1091     cleanup) command_cleanup;;
1092     *) command_help; exit 1;;
1093   esac
1094 }
1095
1096 # Determine OS type
1097 OSTYPE="$(uname)"
1098
1099 # Check for missing dependencies
1100 check_dependencies
1101
1102 # Run script
1103 main "${@:-}"